On Quantum Algorithm for Binary Search and Its Computational Complexity

†S.Iriyama, †M.Ohya and ‡I.V.Volovich
†Tokyo University of Science, Japan
‡Steklov Mathematical Institute, Russia
Abstract

A new quantum algorithm for a search problem and its computational complexity are discussed. It is shown in the search problem containing 2nsuperscript2𝑛2^{n} objects that our algorithm runs in polynomial time.

1 Introduction

Let X𝑋X and Y𝑌Y be two finite sets and a function f:XY:𝑓𝑋𝑌f:X\rightarrow Y. A search problem is to find xX𝑥𝑋x\in X such that f(x)=y𝑓𝑥𝑦f\left(x\right)=y for a given yY𝑦𝑌y\in Y. There are two different cases for the search problem: (S1) one is the case that we know there exists at least one solution x𝑥x of f(x)=y𝑓𝑥𝑦f\left(x\right)=y in X𝑋X. (S2) The other is the case that we do not know the existence of such a solution. The second one is more difficult than the first one. S1 belongs to a class NP, however S2 does to a class NP-hard[1].

The search problem has been originally discussed by Levin[2, 3], and Solomonoff[4] described an algorithm of it. A quantum algorithm of the search problem S1 was proposed by Grover in 1996[5]. The computational complexity of Grover’s searching algorithm is a square root of the cardinality of X𝑋X denoted by card{X}𝑐𝑎𝑟𝑑𝑋card\{X\}.

In this paper, we studied the new quantum algorithm of the search problem S1 and S2 whose computational complexity is polynomial of card{X}𝑐𝑎𝑟𝑑𝑋card\{X\}. The idea of this quantum algorithm is based on the amplification process of the OMV-SAT algorithm[6, 7, 9].

2 Search Problem

Since S2 contains S1 as a special case, we will discuss S2 only here. A search problem is defined by the following.

Problem 1

(S2) For a given f𝑓f andyY𝑦𝑌\ y\in Y, we ask whether there exists xX𝑥𝑋x\in X such that f(x)=y𝑓𝑥𝑦f\left(x\right)=y.

Without loss of generality for discrete cases, we take X={0,1,,2n1}𝑋01superscript2𝑛1X=\left\{0,1,\cdots,2^{n}-1\right\} and Y={0,1}𝑌01Y=\left\{0,1\right\}. Let Mf,X,Ysubscript𝑀𝑓𝑋𝑌M_{f,X,Y} be a Turing machine calculating f(x)𝑓𝑥f\left(x\right) and checking whether f(x)=y𝑓𝑥𝑦f\left(x\right)=y with xX𝑥𝑋x\in X and yY𝑦𝑌y\in Y. It outputs 111 when f(x)=y𝑓𝑥𝑦f\left(x\right)=y, 00 otherwise. To solve this problem, one can construct a Turing machine Mfsubscript𝑀𝑓M_{f} running as follows:

Step1: Set a counter i=0𝑖0i=0.

Step2: If i>2n1𝑖superscript2𝑛1i>2^{n}-1, then Mfsubscript𝑀𝑓M_{f} outputs ”reject”, else calls Mf,X,Ysubscript𝑀𝑓𝑋𝑌M_{f,X,Y} with the inputs x=i𝑥𝑖x=i and y𝑦y, so that Mfsubscript𝑀𝑓M_{f} obtains the result.

Step3: If the result of Step 2 is 111, then it outputs x𝑥x.

Step4: If the result is 00, then it goes back to Step2 with the counter i+1𝑖1i+1.

In the worst case, Mfsubscript𝑀𝑓M_{f} must call Mf,X,Ysubscript𝑀𝑓𝑋𝑌M_{f,X,Y} for all x𝑥x to check whether f(x)=y𝑓𝑥𝑦f\left(x\right)=y or not, so that the computational complexity of the searching algorithm is the cardinal number of X𝑋X.

In the sequel sections, we construct a quantum algorithm to solve the problem S2, and discuss on the computational complexity of it.

3 Quantum Searching Algorithm

From this section, we use a discrete function f𝑓f. Let n𝑛n be a positive number, and f𝑓f a function from X={0,1,,2n1}𝑋01superscript2𝑛1X=\left\{0,1,\cdots,2^{n}-1\right\} to Y={0,1}𝑌01Y=\left\{0,1\right\}.

We show a quantum algorithm to solve the problem S2. To solve this problem, we denote x𝑥x by the following binary expression

x=k=1n2k1εk,𝑥superscriptsubscript𝑘1𝑛superscript2𝑘1subscript𝜀𝑘x=\sum_{k=1}^{n}2^{k-1}\varepsilon_{k}, (1)

where ε1,,εn{0,1}subscript𝜀1subscript𝜀𝑛01\varepsilon_{1},\cdots,\varepsilon_{n}\in\left\{0,1\right\}.

We divide the problem S2 into several problems as below. Here we start the following problem:

Problem 2

Whether does there exist x𝑥x such that f(x)=1𝑓𝑥1f\left(x\right)=1 with ε1=0subscript𝜀10\varepsilon_{1}=0?

If the answer is ”yes”, namely ε1=0subscript𝜀10\varepsilon_{1}=0, then there exists at least one x=0ε2εn𝑥0subscript𝜀2subscript𝜀𝑛x=0\varepsilon_{2}\cdots\varepsilon_{n} such that f(x)=1𝑓𝑥1f\left(x\right)=1. If the ε10subscript𝜀10\varepsilon_{1}\neq 0, then one considers two cases; the ε1=1subscript𝜀11\varepsilon_{1}=1, or there does not exist any x𝑥x such that f(x)=1𝑓𝑥1f\left(x\right)=1.

We go to the next problem with the result of the above problem:

Problem 3

Whether does there exist x𝑥x such that f(x)=1𝑓𝑥1f\left(x\right)=1 with ε2=0subscript𝜀20\varepsilon_{2}=0 for the obtained ε1subscript𝜀1\varepsilon_{1}?

After solving this problem, we know the value of ε2subscript𝜀2\varepsilon_{2}, for example, when ε2=0subscript𝜀20\varepsilon_{2}=0, x𝑥x is written by 00ε3εn00subscript𝜀3subscript𝜀𝑛00\varepsilon_{3}\cdots\varepsilon_{n} or 10ε3εn10subscript𝜀3subscript𝜀𝑛10\varepsilon_{3}\cdots\varepsilon_{n}.

Furthermore, we check the εi,subscript𝜀𝑖\varepsilon_{i}, i=3,,n𝑖3𝑛i=3,\cdots,n by the same way as above using the information of the bits from ε1subscript𝜀1\varepsilon_{1} to εi1subscript𝜀𝑖1\varepsilon_{i-1}. We run the algorithm from ε1subscript𝜀1\varepsilon_{1} to εnsubscript𝜀𝑛\varepsilon_{n}, and we look for one x𝑥x satisfying f(x)=1𝑓𝑥1f\left(x\right)=1. Finally in the case that the result of the algorithm is x=11𝑥11x=1\cdots 1, we calculate f(11)𝑓11f\left(1\cdots 1\right) and check whether f(11)=1𝑓111f\left(1\cdots 1\right)=1 or not. We conclude that (1) if it becomes 111, x=11𝑥11x=1\cdots 1 is a solution of search problem, and (2) otherwise, there does not exist x𝑥x such that f(x)=1𝑓𝑥1f\left(x\right)=1.

4 Chaos Amplifier

We will use the amplification process to construct the quantum searching algorithm. For this purpose, in this section, let us review the Chaos Amplifier along the papers [6, 7] and the book [9].

Consider the so called logistic map which is given by the equation

xn+1=axn(1xn)ga(x),xn[0,1].formulae-sequencesubscript𝑥𝑛1𝑎subscript𝑥𝑛1subscript𝑥𝑛subscript𝑔𝑎𝑥subscript𝑥𝑛01x_{n+1}=ax_{n}(1-x_{n})\equiv g_{a}(x),~{}~{}~{}x_{n}\in\left[0,1\right]. (2)

The properties of the map depend on the parameter a.𝑎a. If we take, for example, a=3.71,𝑎3.71a=3.71, then the Lyapunov exponent is positive, the trajectory is very sensitive to the initial value and one has the chaotic behavior. It is important to notice that if the initial value x0=0,subscript𝑥00x_{0}=0, then xn=0subscript𝑥𝑛0x_{n}=0 for all n.𝑛n.

In the sequel sections, when we get the last qubit such that

ρ=(1p)|00|+p|11|,𝜌1𝑝ket0quantum-operator-product0𝑝1bra1\rho=\left(1-p\right)\left|0\right\rangle\left\langle 0\right|+p\left|1\right\rangle\left\langle 1\right|, (3)

one has to generate that an Abelian algebra by |00|ket0bra0\left|0\right\rangle\left\langle 0\right| and |11|ket1bra1\left|1\right\rangle\left\langle 1\right| which can be considered as a classical system. If p𝑝p is very small, e.g., p=12n𝑝1superscript2𝑛p=\frac{1}{2^{n}} with a large n𝑛n, it is practically difficult to distinguish p=0𝑝0p=0 and p=12n𝑝1superscript2𝑛p=\frac{1}{2^{n}}, then we use the Chaos Amplifier in the following manner.

Let ΛCAsubscriptΛ𝐶𝐴\Lambda_{CA} be a quantum channel on one qubit space such that

ΛCA(ρ)=(I+ga(ρ)σ3)2,subscriptΛ𝐶𝐴𝜌𝐼subscript𝑔𝑎𝜌subscript𝜎32\Lambda_{CA}\left(\rho\right)=\frac{\left(I+g_{a}\left(\rho\right)\sigma_{3}\right)}{2}, (4)

where I𝐼I is the identity matrix and σ3subscript𝜎3\sigma_{3} is the z-component of Pauli matrices. Let k𝑘k be a positive integer, applying (ΛCA)ksuperscriptsubscriptΛ𝐶𝐴𝑘\left(\Lambda_{CA}\right)^{k} to ρ𝜌\rho, we have

(ΛCA)k(ρ)=(I+gak(p)σ3)2=ρk.superscriptsubscriptΛ𝐶𝐴𝑘𝜌𝐼superscriptsubscript𝑔𝑎𝑘𝑝subscript𝜎32subscript𝜌𝑘\left(\Lambda_{CA}\right)^{k}\left(\rho\right)=\frac{(I+g_{a}^{k}(p)\sigma_{3})}{2}=\rho_{k}. (5)

To find a proper value k𝑘k we finally measure the value of σ3subscript𝜎3\sigma_{3} in the state ρksubscript𝜌𝑘\rho_{k} such that

xktrρkσ3.subscript𝑥𝑘trsubscript𝜌𝑘subscript𝜎3x_{k}\equiv\text{tr}\rho_{k}\sigma_{3}. (6)

The following theorems is proven in [6, 7, 9].

Theorem 4

For the logistic map xn+1=axn(1xn)subscript𝑥𝑛1𝑎subscript𝑥𝑛1subscript𝑥𝑛x_{n+1}=ax_{n}\left(1-x_{n}\right) with a[0,4]𝑎04a\in\left[0,4\right] and x0[0,1]subscript𝑥001x_{0}\in\left[0,1\right], let x0subscript𝑥0x_{0} be 12n1superscript2𝑛\frac{1}{2^{n}} and a set J𝐽J be {0,1,2,,n,,2n}012𝑛2𝑛\left\{0,1,2,\dots,n,\dots,2n\right\}. If a𝑎a is 3.713.713.71, then there exists an integer k𝑘k in J𝐽J satisfying xk>12.subscript𝑥𝑘12x_{k}>\frac{1}{2}.

Theorem 5

Let a𝑎a and n𝑛n be the same in above theorem. If there exists k𝑘k in J𝐽J such that xk>12,subscript𝑥𝑘12x_{k}>\frac{1}{2}, then

k>n1log23.711>54(n1).𝑘𝑛1subscript23.71154𝑛1k>\frac{n-1}{\log_{2}3.71-1}>\frac{5}{4}\left(n-1\right). (7)

Using these theorems, we can easily check whether the state ρ=|00|𝜌ket0bra0\rho=\left|0\right\rangle\left\langle 0\right| or not. Note that this amplification process can be written in the generalized Turing machine form [8], and it is related to the semigroup dynamics [10].

5 Quantum Binary Searching Algorithm

Let m𝑚m be a positive integer which can be written by a polynomial in n𝑛n. Let =(2)n+m+1superscriptsuperscript2tensor-productabsent𝑛𝑚1\mathcal{H}=\left(\mathbb{C}^{2}\right)^{\otimes n+m+1} be a Hilbert space. The m𝑚m qubits are used for the computation of f𝑓f, and the dust qubits are produced by this computation. When f𝑓f is given, we can fix m𝑚m. We will show in the next section that this algorithm can be done in a polynomial time.

We construct the following quantum algorithm MQ(1)superscriptsubscript𝑀𝑄1M_{Q}^{\left(1\right)} to solve the problem 2. Let |ψin(1)=|0n|0m|0ketsuperscriptsubscript𝜓𝑖𝑛1tensor-productketsuperscript0𝑛ketsuperscript0𝑚ket0\left|\psi_{in}^{\left(1\right)}\right\rangle=\left|0^{n}\right\rangle\otimes\left|0^{m}\right\rangle\otimes\left|0\right\rangle\in\mathcal{H} be an initial vector for MQ(1)superscriptsubscript𝑀𝑄1M_{Q}^{\left(1\right)}, where the upper index (1)1\left(1\right) comes from the quantum algorithm checking the bit ε1subscript𝜀1\varepsilon_{1}. The last qubit of |ψin(1)ketsuperscriptsubscript𝜓𝑖𝑛1\left|\psi_{in}^{\left(1\right)}\right\rangle is for the answer of it, namely ”yes” or ”no”. If the answer is ”yes”, then the last qubit becomes |1ket1\left|1\right\rangle, otherwise |0ket0\left|0\right\rangle.

The quantum algorithm MQ(1)superscriptsubscript𝑀𝑄1M_{Q}^{\left(1\right)} is given by the following steps. We start MQ(1)superscriptsubscript𝑀𝑄1M_{Q}^{\left(1\right)} with ε1=0subscript𝜀10\varepsilon_{1}=0.

Step1: Apply Hadamard gates from the 222nd qubit to the n𝑛n-th qubit.

IUHn1Im+1|ψin(1)tensor-product𝐼superscriptsubscript𝑈𝐻tensor-productabsent𝑛1superscript𝐼𝑚1ketsuperscriptsubscript𝜓𝑖𝑛1\displaystyle I\otimes U_{H}^{\otimes n-1}\otimes I^{m+1}\left|\psi_{in}^{\left(1\right)}\right\rangle =12n1|ε1(=0)(i=02n11|ei)|0m|0absenttensor-product1superscript2𝑛1ketannotatedsubscript𝜀1absent0superscriptsubscript𝑖0superscript2𝑛11ketsubscript𝑒𝑖ketsuperscript0𝑚ket0\displaystyle=\frac{1}{\sqrt{2^{n-1}}}\left|\varepsilon_{1}\left(=0\right)\right\rangle\otimes\left(\sum_{i=0}^{2^{n-1}-1}\left|e_{i}\right\rangle\right)\otimes\left|0^{m}\right\rangle\otimes\left|0\right\rangle
=|ψ1(1),absentketsuperscriptsubscript𝜓11\displaystyle=\left|\psi_{1}^{\left(1\right)}\right\rangle, (8)

where |eiketsubscript𝑒𝑖\left|e_{i}\right\rangle are

|e0ketsubscript𝑒0\displaystyle\left|e_{0}\right\rangle =|00absentket00\displaystyle=\left|0\cdots 0\right\rangle
|e1ketsubscript𝑒1\displaystyle\left|e_{1}\right\rangle =|10absentket10\displaystyle=\left|1\cdots 0\right\rangle
\displaystyle\vdots
|e2n11ketsubscript𝑒superscript2𝑛11\displaystyle\left|e_{2^{n-1}-1}\right\rangle =|11.absentket11\displaystyle=\left|1\cdots 1\right\rangle. (9)

Let Ufsubscript𝑈𝑓U_{f} be the unitary operator on =(2)n+m+1superscriptsuperscript2tensor-productabsent𝑛𝑚1\mathcal{H}=\left(\mathbb{C}^{2}\right)^{\otimes n+m+1} to compute f𝑓f, defined by

Uf|x|0m|0=|x|zx|f(x),tensor-productsubscript𝑈𝑓ket𝑥ketsuperscript0𝑚ket0tensor-productket𝑥ketsubscript𝑧𝑥ket𝑓𝑥U_{f}\left|x\right\rangle\otimes\left|0^{m}\right\rangle\otimes\left|0\right\rangle=\left|x\right\rangle\otimes\left|z_{x}\right\rangle\otimes\left|f\left(x\right)\right\rangle, (10)

where zxsubscript𝑧𝑥z_{x} is the dust qubit produced by the computation.

Step2: Apply the unitary operator Ufsubscript𝑈𝑓U_{f} to the state made in Step1, and store the result in the last qubit.

Uf|ψ1(1)subscript𝑈𝑓ketsuperscriptsubscript𝜓11\displaystyle U_{f}\left|\psi_{1}^{\left(1\right)}\right\rangle =12n1|0(i=02n11|ei|zi|f(0ei))absenttensor-product1superscript2𝑛1ket0superscriptsubscript𝑖0superscript2𝑛11tensor-productketsubscript𝑒𝑖ketsubscript𝑧𝑖ket𝑓0subscript𝑒𝑖\displaystyle=\frac{1}{\sqrt{2^{n-1}}}\left|0\right\rangle\otimes\left(\sum_{i=0}^{2^{n-1}-1}\left|e_{i}\right\rangle\otimes\left|z_{i}\right\rangle\otimes\left|f\left(0e_{i}\right)\right\rangle\right)
=|ψ2(1),absentketsuperscriptsubscript𝜓21\displaystyle=\left|\psi_{2}^{\left(1\right)}\right\rangle, (11)

where zisubscript𝑧𝑖z_{i} is the dust qubits depending on eisubscript𝑒𝑖e_{i}.

Step3: We take the last qubit by the projection from the final state |ψ2(1)ketsuperscriptsubscript𝜓21\left|\psi_{2}^{\left(1\right)}\right\rangle such that

(1p)|00|+p|11|,1𝑝ket0quantum-operator-product0𝑝1bra1\left(1-p\right)\left|0\right\rangle\left\langle 0\right|+p\left|1\right\rangle\left\langle 1\right|, (12)

where p=card{x|f(x)=1,x=0ε2εn}/2n1𝑝𝑐𝑎𝑟𝑑conditional-set𝑥formulae-sequence𝑓𝑥1𝑥0subscript𝜀2subscript𝜀𝑛superscript2𝑛1p=card\left\{x|f\left(x\right)=1,x=0\varepsilon_{2}\cdots\varepsilon_{n}\right\}/2^{n-1}, and this state is the state ρ𝜌\rho given in the previous section.

Step4: After the above formula, the state is a pure state or a mixed state. If the state is mixed and p0𝑝0p\neq 0 however very small, then apply the Chaos Amplifier given in the Section4 to check whether the last qubit is in the state |11|ket1bra1\left|1\right\rangle\left\langle 1\right|. If we find that the last qubit is in the state |11|ket1bra1\left|1\right\rangle\left\langle 1\right|, then p0𝑝0p\neq 0, which implies that there exists at least one solution of f(x)=1𝑓𝑥1f\left(x\right)=1 for ε1=0subscript𝜀10\varepsilon_{1}=0. If we do not find that the last qubit is in the state |11|ket1bra1\left|1\right\rangle\left\langle 1\right|, namely p=0𝑝0p=0, then there are two possibilities that are ε1=1subscript𝜀11\varepsilon_{1}=1 or no solutions xX𝑥𝑋x\in X of f(x)=1𝑓𝑥1f\left(x\right)=1.

After this algorithm, we know that if ε1=0subscript𝜀10\varepsilon_{1}=0 or 111, then the last qubit is 111 or 00, respectively. We write this process as MQ(1)(0n)=ε1superscriptsubscript𝑀𝑄1superscript0𝑛subscript𝜀1M_{Q}^{\left(1\right)}\left(0^{n}\right)=\varepsilon_{1} where 0nsuperscript0𝑛0^{n} means the initial vector.

Next we modify Step1 of the algorithm MQ(1)superscriptsubscript𝑀𝑄1M_{Q}^{\left(1\right)} as:

Step1: Apply Hadamard gates from 333rd qubit to n𝑛n-th qubit.

And we call this algorithm MQ(2)superscriptsubscript𝑀𝑄2M_{Q}^{\left(2\right)}. The index (2)2\left(2\right) means that the algorithm check ε2subscript𝜀2\varepsilon_{2}. We start MQ(2)superscriptsubscript𝑀𝑄2M_{Q}^{\left(2\right)} with the initial vector |ψin(2)=|ε1,0n1|0m|0ketsuperscriptsubscript𝜓𝑖𝑛2tensor-productketsubscript𝜀1superscript0𝑛1ketsuperscript0𝑚ket0\left|\psi_{in}^{\left(2\right)}\right\rangle=\left|\varepsilon_{1},0^{n-1}\right\rangle\otimes\left|0^{m}\right\rangle\otimes\left|0\right\rangle instead of |ψin(1)ketsuperscriptsubscript𝜓𝑖𝑛1\left|\psi_{in}^{\left(1\right)}\right\rangle.

So forth we obtain the bit ε2subscript𝜀2\varepsilon_{2}, and write as MQ(2)(ε1,0n1)=MQ(2)(MQ(1)(0n),0n1)=ε2superscriptsubscript𝑀𝑄2subscript𝜀1superscript0𝑛1superscriptsubscript𝑀𝑄2superscriptsubscript𝑀𝑄1superscript0𝑛superscript0𝑛1subscript𝜀2M_{Q}^{\left(2\right)}\left(\varepsilon_{1},0^{n-1}\right)=M_{Q}^{\left(2\right)}\left(M_{Q}^{\left(1\right)}\left(0^{n}\right),0^{n-1}\right)=\varepsilon_{2}.

In generally, we write the algorithm MQ(i)(ε1,ε2,,εi1,0ni+1)superscriptsubscript𝑀𝑄𝑖subscript𝜀1subscript𝜀2subscript𝜀𝑖1superscript0𝑛𝑖1M_{Q}^{\left(i\right)}\left(\varepsilon_{1},\varepsilon_{2},\cdots,\varepsilon_{i-1},0^{n-i+1}\right) for an initial vector |ψin(i)=|ε1,ε2,,εi1,0ni+1|0m|0ketsuperscriptsubscript𝜓𝑖𝑛𝑖tensor-productketsubscript𝜀1subscript𝜀2subscript𝜀𝑖1superscript0𝑛𝑖1ketsuperscript0𝑚ket0\left|\psi_{in}^{\left(i\right)}\right\rangle=\left|\varepsilon_{1},\varepsilon_{2},\cdots,\varepsilon_{i-1},0^{n-i+1}\right\rangle\otimes\left|0^{m}\right\rangle\otimes\left|0\right\rangle as the following:

Step1: Apply Hadamard gates from i+1𝑖1i+1-th to n𝑛n-th qubits.

IiUHniIm+1|ψin(i)tensor-productsuperscript𝐼tensor-productabsent𝑖superscriptsubscript𝑈𝐻tensor-productabsent𝑛𝑖superscript𝐼𝑚1ketsuperscriptsubscript𝜓𝑖𝑛𝑖\displaystyle I^{\otimes i}\otimes U_{H}^{\otimes n-i}\otimes I^{m+1}\left|\psi_{in}^{\left(i\right)}\right\rangle =12ni|ε1,ε2,,εi1(k=02ni1|ek)|0m|0absenttensor-product1superscript2𝑛𝑖ketsubscript𝜀1subscript𝜀2subscript𝜀𝑖1superscriptsubscript𝑘0superscript2𝑛𝑖1ketsubscript𝑒𝑘ketsuperscript0𝑚ket0\displaystyle=\frac{1}{\sqrt{2^{n-i}}}\left|\varepsilon_{1},\varepsilon_{2},\cdots,\varepsilon_{i-1}\right\rangle\otimes\left(\sum_{k=0}^{2^{n-i}-1}\left|e_{k}\right\rangle\right)\otimes\left|0^{m}\right\rangle\otimes\left|0\right\rangle
=|ψ1(i).absentketsuperscriptsubscript𝜓1𝑖\displaystyle=\left|\psi_{1}^{\left(i\right)}\right\rangle. (13)

Step2: Apply the unitary gate to compute f𝑓f for the superposition made in Step1, and store the result in n+m+1𝑛𝑚1n+m+1-th qubit.

Uf|ψ1(i)subscript𝑈𝑓ketsuperscriptsubscript𝜓1𝑖\displaystyle U_{f}\left|\psi_{1}^{\left(i\right)}\right\rangle =12ni|ε1,ε2,,εi1(k=02n11|ek|zk|f(ε1,ε2,,εi1,ek))absenttensor-product1superscript2𝑛𝑖ketsubscript𝜀1subscript𝜀2subscript𝜀𝑖1superscriptsubscript𝑘0superscript2𝑛11tensor-productketsubscript𝑒𝑘ketsubscript𝑧𝑘ket𝑓subscript𝜀1subscript𝜀2subscript𝜀𝑖1subscript𝑒𝑘\displaystyle=\frac{1}{\sqrt{2^{n-i}}}\left|\varepsilon_{1},\varepsilon_{2},\cdots,\varepsilon_{i-1}\right\rangle\otimes\left(\sum_{k=0}^{2^{n-1}-1}\left|e_{k}\right\rangle\otimes\left|z_{k}\right\rangle\otimes\left|f\left(\varepsilon_{1},\varepsilon_{2},\cdots,\varepsilon_{i-1},e_{k}\right)\right\rangle\right)
=|ψ2(i).absentketsuperscriptsubscript𝜓2𝑖\displaystyle=\left|\psi_{2}^{\left(i\right)}\right\rangle. (14)

Step3: Take the last qubit by the projection from the final state |ψ2(i)ketsuperscriptsubscript𝜓2𝑖\left|\psi_{2}^{\left(i\right)}\right\rangle such that

(1p)|00|+p|11|.1𝑝ket0quantum-operator-product0𝑝1bra1\left(1-p\right)\left|0\right\rangle\left\langle 0\right|+p\left|1\right\rangle\left\langle 1\right|. (15)

Step4: Apply the Chaos Amplifier to the amplitude p𝑝p, so that we can easily find that the last qubit is |11|ket1bra1\left|1\right\rangle\left\langle 1\right|.

After this algorithm MQ(i)(ε1,ε2,,εi1,0ni+1)superscriptsubscript𝑀𝑄𝑖subscript𝜀1subscript𝜀2subscript𝜀𝑖1superscript0𝑛𝑖1M_{Q}^{\left(i\right)}\left(\varepsilon_{1},\varepsilon_{2},\cdots,\varepsilon_{i-1},0^{n-i+1}\right), we know the bit εisubscript𝜀𝑖\varepsilon_{i} such that f(x)=1𝑓𝑥1f\left(x\right)=1. Each MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)}, i2𝑖2i\geq 2 use the result of all MQ(j)superscriptsubscript𝑀𝑄𝑗M_{Q}^{\left(j\right)} (j<i)𝑗𝑖\left(j<i\right) as an initial vector. We run this algorithm MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)} for each i𝑖i (i=1,,n)𝑖1𝑛\left(i=1,\cdots,n\right).

6 Computational Complexity of the Quantum Binary Search Algorithm

In this section, we calculate the computational complexity of the quantum algorithm for binary search. The computational complexity is the number of total unitary gates discussed above and amplification channels in our search algorithm.

In the above section, the quantum algorithm for binary search is given by the products of unitary gates denoted by Uisubscript𝑈𝑖U_{i} below. Let |ψin(i)ketsuperscriptsubscript𝜓𝑖𝑛𝑖\left|\psi_{in}^{\left(i\right)}\right\rangle be an initial vector for the algorithm MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)} as

|ψin(i)=|ε1εi1,0ni|0m|0,ketsuperscriptsubscript𝜓𝑖𝑛𝑖tensor-productketsubscript𝜀1subscript𝜀𝑖1superscript0𝑛𝑖ketsuperscript0𝑚ket0\left|\psi_{in}^{\left(i\right)}\right\rangle=\left|\varepsilon_{1}\cdots\varepsilon_{i-1},0^{n-i}\right\rangle\otimes\left|0^{m}\right\rangle\otimes\left|0\right\rangle, (16)

and it goes to the final vector

Ui|ψin(i)subscript𝑈𝑖ketsuperscriptsubscript𝜓𝑖𝑛𝑖\displaystyle U_{i}\left|\psi_{in}^{\left(i\right)}\right\rangle =12ni|ε1,,εi1(k=02n11|ek|zk|f(ε1,,εi1,ek))absenttensor-product1superscript2𝑛𝑖ketsubscript𝜀1subscript𝜀𝑖1superscriptsubscript𝑘0superscript2𝑛11tensor-productketsubscript𝑒𝑘ketsubscript𝑧𝑘ket𝑓subscript𝜀1subscript𝜀𝑖1subscript𝑒𝑘\displaystyle=\frac{1}{\sqrt{2^{n-i}}}\left|\varepsilon_{1},\cdots,\varepsilon_{i-1}\right\rangle\otimes\left(\sum_{k=0}^{2^{n-1}-1}\left|e_{k}\right\rangle\otimes\left|z_{k}\right\rangle\otimes\left|f\left(\varepsilon_{1},\cdots,\varepsilon_{i-1},e_{k}\right)\right\rangle\right)
=|ψ2(i),absentketsuperscriptsubscript𝜓2𝑖\displaystyle=\left|\psi_{2}^{\left(i\right)}\right\rangle, (17)

where f(ε1,,εi1,ek)𝑓subscript𝜀1subscript𝜀𝑖1subscript𝑒𝑘f\left(\varepsilon_{1},\cdots,\varepsilon_{i-1},e_{k}\right) is the result of the objective function for a search problem. The above unitary gates Uisubscript𝑈𝑖U_{i} for the algorithm MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)} are defined by

Ui=Uf(UH)ni{xk|xk=1}UNOT(k),subscript𝑈𝑖subscript𝑈𝑓superscriptsubscript𝑈𝐻tensor-productabsent𝑛𝑖subscriptproductconditional-setsubscript𝑥𝑘subscript𝑥𝑘1subscript𝑈𝑁𝑂𝑇𝑘U_{i}=U_{f}\left(U_{H}\right)^{\otimes n-i}{\displaystyle\prod\limits_{\left\{x_{k}|x_{k}=1\right\}}}U_{NOT}\left(k\right), (18)

where UNOT(k)subscript𝑈𝑁𝑂𝑇𝑘U_{NOT}\left(k\right) is to apply the NOT gate for the k𝑘k-th qubit only when the result of stage k𝑘k is 111, (k=1,2,i1)𝑘12𝑖1\left(k=1,2,\cdots i-1\right) .

The computational complexity T𝑇T of the quantum binary search algorithm T(Un)𝑇subscript𝑈𝑛T\left(U_{n}\right) is given by the total number of unitary gates and quantum channels for the amplification. We obtain the following theorem.

Theorem 6

We have

T=[138n294n+nT(Uf)]+1,𝑇delimited-[]138superscript𝑛294𝑛𝑛𝑇subscript𝑈𝑓1T=\left[\frac{13}{8}n^{2}-\frac{9}{4}n+nT\left(U_{f}\right)\right]+1, (19)

where []delimited-[]\left[\cdot\right] means the Gauss symbol, and T(Uf)𝑇subscript𝑈𝑓T\left(U_{f}\right) is a given complexity associated to the function f𝑓f.

Proof. For the algorithm MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)}, one should have the following gates: i1𝑖1i-1 NOT gates, ni𝑛𝑖n-i Hadamard gates and Ufsubscript𝑈𝑓U_{f}, so that the computational complexity Tisubscript𝑇𝑖T_{i} for the algorithm MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)} is given by

Tisubscript𝑇𝑖\displaystyle T_{i} =ni+i1+T(Uf)absent𝑛𝑖𝑖1𝑇subscript𝑈𝑓\displaystyle=n-i+i-1+T\left(U_{f}\right)
=n1+T(Uf).absent𝑛1𝑇subscript𝑈𝑓\displaystyle=n-1+T\left(U_{f}\right). (20)

The total number of stages is n𝑛n, then the computational complexity is

i=1nTi=n(n1)+nT(Uf).superscriptsubscript𝑖1𝑛subscript𝑇𝑖𝑛𝑛1𝑛𝑇subscript𝑈𝑓\sum_{i=1}^{n}T_{i}=n\left(n-1\right)+nT\left(U_{f}\right). (21)

For the amplification process explained above, the number of amplification channels for n𝑛n qubits was shown as

[54(n1)]+1.delimited-[]54𝑛11\left[\frac{5}{4}\left(n-1\right)\right]+1. (22)

In the algorithm MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)}, we have to apply [54(n1)]+1delimited-[]54𝑛11\left[\frac{5}{4}\left(n-1\right)\right]+1 times amplification channels for (ni)𝑛𝑖\left(n-i\right) qubits at worst. Then the number of total quantum channels is calculated as

12n(54(n11)+0)[58n(n2)]+1.12𝑛54𝑛110delimited-[]58𝑛𝑛21\frac{1}{2}n\left(\frac{5}{4}\left(n-1-1\right)+0\right)\leq\left[\frac{5}{8}n\left(n-2\right)\right]+1. (23)

Therefore the computational complexity T𝑇T becomes

T𝑇\displaystyle T =i=1nT(Ui)+[58n(n2)]+1absentsuperscriptsubscript𝑖1𝑛𝑇subscript𝑈𝑖delimited-[]58𝑛𝑛21\displaystyle=\sum_{i=1}^{n}T\left(U_{i}\right)+\left[\frac{5}{8}n\left(n-2\right)\right]+1
=n(n1)+nT(Uf)+[58n(n2)]+1absent𝑛𝑛1𝑛𝑇subscript𝑈𝑓delimited-[]58𝑛𝑛21\displaystyle=n\left(n-1\right)+nT\left(U_{f}\right)+\left[\frac{5}{8}n\left(n-2\right)\right]+1
[138n294n+nT(Uf)]+1.absentdelimited-[]138superscript𝑛294𝑛𝑛𝑇subscript𝑈𝑓1\displaystyle\leq\left[\frac{13}{8}n^{2}-\frac{9}{4}n+nT\left(U_{f}\right)\right]+1. (24)

 

Note that the above T(Uf)𝑇subscript𝑈𝑓T\left(U_{f}\right) is essentially polynomial in n𝑛n.

7 Conclusion

In this paper, we constructed the quantum algorithm for searching probrem S2 for a given f𝑓f andyY𝑦𝑌\ y\in Y with the cardinal number of X;card{X}=2n𝑋𝑐𝑎𝑟𝑑𝑋superscript2𝑛X;card\left\{X\right\}=2^{n}. Our quantum algorithm can be written in a combination of quantum algorithms MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)} for i=1,,n𝑖1𝑛i=1,\cdots,n. The each quantum algorithms are run sequentially, in the other words, MQ(i)superscriptsubscript𝑀𝑄𝑖M_{Q}^{\left(i\right)} uses the result of MQ(i1)superscriptsubscript𝑀𝑄𝑖1M_{Q}^{\left(i-1\right)}. This quantum algorithm is able to check whether there exists a cirtain x𝑥x such that f(x)=y𝑓𝑥𝑦f\left(x\right)=y or not; it solved an NP-hard problem. We proved that the computational complexity of our quantum searching algorithm is polynomial in n𝑛n.

References

  • [1] M.R.Garey and D.S.Johnson, Computers and Intractability: A Guide to the Theory of NP-Completeness, W. H. Freeman, 1979
  • [2] L.A.Levin, Universal sequential search problems. Problems of Information Transmission, 9(3):265–266, 1973
  • [3] L.A.Levin, Randomness Conservation Inequalities: Information and Independence in Mathematical Theories. Information and Control, 61:15-37, 1984.
  • [4] R. J. Solomonoff, Optimum sequential search. Memorandum, Oxbridge Research, Cambridge, Mass., June 1984.
  • [5] L.K.Grover, A fast quantum mechanical algorithm for database search, Proceedings, 28th Annual ACM Symposium on the Theory of Computing, p. 212, 1996
  • [6] M.Ohya and I.V.Volovich, New quantum algorithm for studying NP-complete problems, Rep.Math.Phys.,52, No.1,25-33, 2003
  • [7] M.Ohya and I.V.Volovich, Quantum computing and chaotic amplifier, J.Opt.B, 5,No.6 639-642, 2003
  • [8] S.Iriyama and M.Ohya, Language Classes Defined by Generalized Quantum Turing Machine, Open System and Information Dynamics 15:4, 383-396, 2008
  • [9] M.Ohya and I.V.Volovich, Mathematical Foundation of Quantum Information and Computation and Its Applications to Nano- and Bio-systems, Springer Velrag, 2011.
  • [10] S.Iriyama and M.Ohya, On Semigroup Dynaical Representation of Non-linear Chaos Dynamics, in preparation.